'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LanguageProvider = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

var _reactIntl = require('react-intl');

var _selectors = require('./selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LanguageProvider = exports.LanguageProvider = function (_React$PureComponent) {
  _inherits(LanguageProvider, _React$PureComponent);

  function LanguageProvider() {
    _classCallCheck(this, LanguageProvider);

    return _possibleConstructorReturn(this, (LanguageProvider.__proto__ || Object.getPrototypeOf(LanguageProvider)).apply(this, arguments));
  }

  _createClass(LanguageProvider, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactIntl.IntlProvider,
        { locale: this.props.locale, key: this.props.locale, messages: this.props.messages[this.props.locale] },
        _react2.default.Children.only(this.props.children)
      );
    }
  }]);

  return LanguageProvider;
}(_react2.default.PureComponent);

LanguageProvider.propTypes = {
  locale: _react2.default.PropTypes.string,
  messages: _react2.default.PropTypes.object,
  children: _react2.default.PropTypes.element.isRequired
};

var mapStateToProps = (0, _reselect.createSelector)((0, _selectors.makeSelectLocale)(), function (locale) {
  return { locale: locale };
});

module.exports = (0, _reactRedux.connect)(mapStateToProps)(LanguageProvider);