'use strict';

var _immutable = require('immutable');

var _constants = require('./constants');

module.exports = function (DEFAULT_LOCALE) {
  var initialState = (0, _immutable.fromJS)({
    locale: DEFAULT_LOCALE
  });

  return {
    reducer: function reducer() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      switch (action.type) {
        case _constants.CHANGE_LOCALE:
          return state.set('locale', action.locale);
        default:
          return state;
      }
    }
  };
};