'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

// Boilerplate reduction for dynamic routes

var errorLoading = function errorLoading(err) {
  return console.error('Dynamic page loading failed', err);
};

var loadModule = function loadModule(cb) {
  return function (componentModule) {
    return cb(null, componentModule.default);
  };
};

var injectAndRender = function injectAndRender(injectReducer, reducer, injectSagas, sagas, renderRoute, component) {
  injectReducer('home', reducer.default);
  injectSagas(sagas.default);
  renderRoute(component);
};

var createRoutes = function createRoutes(store, routes, getAsyncInjectors, createReducer) {
  var _getAsyncInjectors = getAsyncInjectors(store, createReducer),
      injectReducer = _getAsyncInjectors.injectReducer,
      injectSagas = _getAsyncInjectors.injectSagas;

  return routes.map(function (item) {
    var result = {
      path: item.path,
      name: item.name
    };
    if (typeof item.component.length !== 'undefined') {
      Object.assign(result, {
        getComponent: function getComponent(nextState, cb) {
          var renderRoute = loadModule(cb);
          Promise.all(item.component).then(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 3),
                reducer = _ref2[0],
                sagas = _ref2[1],
                component = _ref2[2];

            return injectAndRender(injectReducer, reducer, injectSagas, sagas, renderRoute, component);
          }).catch(errorLoading);
        }
      });
    } else {
      Object.assign(result, {
        getComponent: function getComponent(nextState, cb) {
          item.component.then(loadModule(cb)).catch(errorLoading);
        }
      });
    }
    return result;
  });
};

module.exports = {
  errorLoading: errorLoading,
  loadModule: loadModule,
  injectAndRender: injectAndRender,
  createRoutes: createRoutes
};