'use strict';

var chalk = require('chalk');
var ip = require('ip');
var divider = chalk.gray('\n-----------------------------------');

var logger = {
  error: function error(err) {
    return console.error(chalk.red(err));
  },

  appStarted: function appStarted(port, host, tunnelStarted) {
    console.log('Server started ! ' + chalk.green('✓'));
    if (tunnelStarted) {
      console.log('Tunnel initialised ' + chalk.green('✓'));
    }
    console.log('\n' + chalk.bold('Access URLs:') + divider + '\nLocalhost: ' + chalk.magenta('http://' + host + ':' + port) + '\n      LAN: ' + (chalk.magenta('http://' + ip.address() + ':' + port) + (tunnelStarted ? '\n    Proxy: ' + chalk.magenta(tunnelStarted) : '')) + divider + '\n' + chalk.blue('Press ' + chalk.italic('CTRL-C') + ' to stop') + '\n    ');
  }
};

module.exports = logger;