import { fromJS } from 'immutable';
import { CHANGE_LOCALE} from './constants';

module.exports = (DEFAULT_LOCALE) => {
  const initialState = fromJS({
    locale: DEFAULT_LOCALE
  });

  return {
    reducer: (state = initialState, action = {}) => {
      switch (action.type) {
        case CHANGE_LOCALE:
          return state.set('locale', action.locale);
        default:
          return state;
      }
    }
  }
}
